codeforces 749

A 给你一个N 让你拆分成 个数最多 和素数的和

偶数 2 ...  奇数 2... 3

#include<stdio.h>
#include<algorithm>
#include<cstring>
#include<string>
#include<cmath>
#include<vector>
#include<queue>

using namespace std;

#define LL   __int64
#define MAXN 510
#define inf  1000000000

int main()
{
    int n;
    scanf("%d",&n);
    if(n%2==0)
    {
        printf("%d\n",n/2);
        for(int i=1;i<n/2;i++)
            printf("2 ");
        printf("2\n");
    }
    else
    {
        printf("%d\n",(n-3)/2+1);
        for(int i=1;i<=(n-3)/2;i++)
            printf("2 ");
        printf("3\n");
    }
    return 0;
}

B  给你3个点 让你求第四个点 与前三个点组成平行四边形  3种可能 输出来

#include<stdio.h>
#include<algorithm>
#include<cstring>
#include<string>
#include<cmath>
#include<vector>
#include<queue>

using namespace std;

#define LL   __int64
#define MAXN 510
#define inf  1000000000

int main()
{
    int x1,y1,x2,y2,x3,y3;
    scanf("%d%d%d%d%d%d",&x1,&y1,&x2,&y2,&x3,&y3);
    printf("3\n");
    printf("%d %d\n",x1+x3-x2,y1+y3-y2);
    printf("%d %d\n",x2+x1-x3,y2+y1-y3);
    printf("%d %d\n",x3+x2-x1,y3+y2-y1);
    return 0;
}

C     D R 吵架 D能举报R R也能举报D

被举报了 就不能再举报了  问最后是哪边 赢

模拟一下就行了

#include<stdio.h>
#include<algorithm>
#include<cstring>
#include<string>
#include<cmath>
#include<vector>
#include<queue>

using namespace std;

#define LL   __int64
#define MAXN 200010
#define inf  1000000000

char z[MAXN];

int main()
{
    int d,r;
    int len;
    int n;
    scanf("%d",&len);
    scanf("%s",z);
    d=r=0;
    int ar,ad;
    ar=ad=0;
    for(int i=0;i<len;i++)
        if(z[i]==‘D‘)
            ad++;
        else
            ar++;
    char an;
    if(ad==0)
    {
        printf("R\n");
        return 0;
    }
    if(ar==0)
    {
        printf("D\n");
        return 0;
    }
    while(1)
    {
        for(int i=0;i<len;i++)
        {
            if(z[i]==‘D‘)
            {
                if(r>0)
                {
                    r--;
                    ad--;
                    z[i]=‘ ‘;
                    if(ad==0)
                    {
                        an=‘R‘;
                        break;
                    }
                }
                else
                    d++;
            }
            else if(z[i]==‘R‘)
            {
                if(d>0)
                {
                     d--;
                     ar--;
                     z[i]=‘ ‘;
                     if(ar==0)
                     {
                         an=‘D‘;
                         break;
                     }
                }
                else
                    r++;
            }
        }
        if(ar==0||ad==0)
            break;
    }
    printf("%c\n",an);
    return 0;
}

时间: 2024-12-31 19:25:25

codeforces 749的相关文章

【codeforces 749E】 Inversions After Shuffle

http://codeforces.com/problemset/problem/749/E (题目链接) 题意 给出一个1~n的排列,从中等概率的选取一个连续段,设其长度为l.对连续段重新进行等概率的全排列,求排列后整个原序列的逆序对的期望个数. Solution 考虑对于每一对数${(a_i,a_j),i<j}$算贡献. 1.连续段包含${a_i,a_j}$ 不妨设${a_i<a_j}$,则只有当排列后${a_j}$再${a_i}$前面才会对答案有贡献(${a_i>a_j}$的情况同

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l